-- Saisir ici vos instructions ddl (executables a partir de grhum ou d'un user dba)

----------------CREATION DES VUES-------------------------------------------------------
--Vues utilisées pour le treeview des salles
CREATE OR REPLACE FORCE VIEW "GRHUM"."V_ETAGE_LOCAL" ("C_LOCAL", "SAL_ETAGE")
AS
  SELECT DISTINCT s.c_local,
    s.sal_etage
  FROM salles s where s.d_annulation is null
  ORDER BY 1,2;
  
 CREATE OR REPLACE FORCE VIEW "GRHUM"."V_TYPE_SALLE_LOCAL_ETAGE" ("C_LOCAL", "SAL_ETAGE", "TSAL_NUMERO")
AS
  SELECT DISTINCT s.c_local,
    s.sal_etage,
    s.tsal_numero
  FROM salles s  where s.d_annulation is null
  ORDER BY 1,2,3;

--------------------CREATION DES TABLES---------------------------------------------------

CREATE sequence GRHUM.TYPE_OCCUPATION_SEQ;
CREATE TABLE "GRHUM"."TYPE_OCCUPATION"
  (
    "TOC_ORDRE"   NUMBER NOT NULL ENABLE,
    "TOC_LIBELLE" VARCHAR2(20 BYTE),
    CONSTRAINT "PK_TYPE_OCCUPATION" PRIMARY KEY ("TOC_ORDRE") ENABLE
  ) ;
  
CREATE TABLE "GRHUM"."TYPE_ACCES_HANDICAPE"
  (
    "LIBELLE"   VARCHAR2(255 BYTE) NOT NULL ENABLE,
    "TAH_ORDRE" NUMBER(10,0) NOT NULL ENABLE,
    PRIMARY KEY ("TAH_ORDRE") ENABLE
  );
 CREATE TABLE "GRHUM"."REPART_SALLE_ACCES_HANDICAPE"
  (
    "SAL_NUMERO" NUMBER NOT NULL ENABLE,
    "TAH_ORDRE"  NUMBER NOT NULL ENABLE,
    CONSTRAINT "RSAH_PK" PRIMARY KEY ("TAH_ORDRE", "SAL_NUMERO") ENABLE,
    CONSTRAINT "REPART_SALLE_ACCES_HANDIC_FK1" FOREIGN KEY ("SAL_NUMERO") REFERENCES "GRHUM"."SALLES" ("SAL_NUMERO") ENABLE,
    CONSTRAINT "REPART_SALLE_ACCES_HANDIC_FK2" FOREIGN KEY ("TAH_ORDRE") REFERENCES "GRHUM"."TYPE_ACCES_HANDICAPE" ("TAH_ORDRE") ENABLE
  ) ;
  CREATE sequence GRHUM.TYPE_ACCES_HANDICAPE_SEQ;
  
   CREATE TABLE "GRHUM"."DETAIL_POURCENTAGE"
  (
    "SAL_NUMERO"      NUMBER,
    "C_STRUCTURE"     VARCHAR2(10 BYTE),
    "DET_POURCENTAGE" NUMBER(12,2),
    "TOC_ORDRE"       NUMBER,
    CONSTRAINT "PK_DETAIL_POURCENTAGE" PRIMARY KEY ("SAL_NUMERO", "C_STRUCTURE", "TOC_ORDRE") ENABLE,
    CONSTRAINT "FK_SALLE_PCT" FOREIGN KEY ("SAL_NUMERO") REFERENCES "GRHUM"."SALLES" ("SAL_NUMERO") ENABLE,
    CONSTRAINT "FK_TYPE_OCCUPATION_PCT" FOREIGN KEY ("TOC_ORDRE") REFERENCES "GRHUM"."TYPE_OCCUPATION" ("TOC_ORDRE") ENABLE,
    CONSTRAINT "FK_STRUCTURE_PCT" FOREIGN KEY ("C_STRUCTURE") REFERENCES "GRHUM"."STRUCTURE_ULR" ("C_STRUCTURE") ENABLE
  ) ;
  
  CREATE TABLE "GRHUM"."SALLE_PORTE"
  (
    "SALLE_PORTE_KEY" NUMBER NOT NULL ENABLE,
    "SAL_NUMERO"      NUMBER NOT NULL ENABLE,
    "SAL_PORTE"       VARCHAR2(20 BYTE),
    "SAL_CB"          VARCHAR2(20 BYTE),
    CONSTRAINT "SALLE_PORTE_PK" PRIMARY KEY ("SALLE_PORTE_KEY") ENABLE,
    CONSTRAINT "SALLE_PORTE_SALLES_FK" FOREIGN KEY ("SAL_NUMERO") REFERENCES "GRHUM"."SALLES" ("SAL_NUMERO") ENABLE
  ) ;
COMMENT ON COLUMN "GRHUM"."SALLE_PORTE"."SALLE_PORTE_KEY" IS  'PK';
  COMMENT ON COLUMN "GRHUM"."SALLE_PORTE"."SAL_PORTE" IS  'Code de la porte';
  COMMENT ON COLUMN "GRHUM"."SALLE_PORTE"."SAL_CB" IS  'Numero de code barre de la porte';
CREATE sequence GRHUM.SALLE_PORTE_SEQ; 
  
CREATE TABLE "GRHUM"."SALLE_TELEPHONE"
  (
    "SAL_TEL_KEY"  NUMBER NOT NULL ENABLE,
    "SAL_NUMERO"   NUMBER NOT NULL ENABLE,
    "NO_TELEPHONE" VARCHAR2(14 BYTE) NOT NULL ENABLE,
    CONSTRAINT "SALLE_TELEPHONE_PK" PRIMARY KEY ("SAL_TEL_KEY") ENABLE,
    CONSTRAINT "SALLE_TELEPHONE_SALLES_FK" FOREIGN KEY ("SAL_NUMERO") REFERENCES "GRHUM"."SALLES" ("SAL_NUMERO") ENABLE
  ) ;
COMMENT ON COLUMN "GRHUM"."SALLE_TELEPHONE"."SAL_TEL_KEY" IS  'Pk salle_telephone';
  COMMENT ON COLUMN "GRHUM"."SALLE_TELEPHONE"."SAL_NUMERO" IS  'FK vers salle';
CREATE SEQUENCE GRHUM.SALLE_TELEPHONE_SEQ;


----------------------MODIFICATION DES TABLES----------------------------------------------
alter table GRHUM.SALLES modify SAL_PORTE VARCHAR2(150);
ALTER TABLE GRHUM.SALLES ADD (D_ANNULATION DATE );


--changement de la PK sur implantation_geo 
CREATE SEQUENCE GRHUM.IMPLANTATION_GEO_SEQ;
alter table IMPLANTATION_GEO add IMGEO_ORDRE number ;
comment on column IMPLANTATION_GEO.IMGEO_ORDRE  is 'PK implantation_geo';
--remplissage de la colonne
update grhum.implantation_geo set imgeo_ordre=grhum.implantation_geo_seq.nextval;
commit;
-- Changement de la cle primaire
alter table IMPLANTATION_GEO  drop constraint PK_IMPLANTATION_GEO cascade;
drop index PK_IMPLANTATION_GEO;
alter table IMPLANTATION_GEO  add constraint PK_IMPLANTATION_GEO primary key (IMGEO_ORDRE);

--changement de la cle de REPART_BAT_IMP_GEO  vers implantation_geo
alter table REPART_BAT_IMP_GEO add imgeo_ordre number;
-- Contrainte cle primaire 
update repart_bat_imp_geo repart set repart.imgeo_ordre= (select imp.imgeo_ordre from implantation_geo imp where imp.c_implantation = repart.c_implantation);
commit;
alter table REPART_BAT_IMP_GEO drop column C_IMPLANTATION cascade constraints;
alter table REPART_BAT_IMP_GEO  add constraint RPIG_PK primary key (IMGEO_ORDRE, C_LOCAL);
alter table REPART_BAT_IMP_GEO  add constraint RPIG_IMP_GEO foreign key (IMGEO_ORDRE) references implantation_geo (IMGEO_ORDRE);

-------------------------creation des sequences manquantes---------------------------------------

CREATE SEQUENCE SALLE.PRISES_SEQ;

declare
  i number;
begin
  select salle.seq_salle.nextval into i from dual;
 EXECUTE IMMEDIATE ' CREATE SEQUENCE GRHUM.SALLES_SEQ MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH '||i||' NOCACHE NOORDER NOCYCLE' ;
  select salle.seq_typesalle.nextval into i from dual;
 EXECUTE IMMEDIATE ' CREATE SEQUENCE GRHUM.TYPE_SALLE_SEQ MINVALUE 1 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH '||i||' NOCACHE NOORDER NOCYCLE' ;

end;